' Deploy SAS Add-In (Version 4) Templates to Visual Studio.NET 2003 directories

' Global variables.
Dim FSO
Dim WSH
Dim CSharpDir
Dim VBDir

Set FSO = CreateObject("Scripting.FileSystemObject")
Set WSH = CreateObject("Wscript.Shell")

If IsSASTasksInstalled = True Then
	Log "Deploying files from " & WSH.CurrentDirectory
Else
	Log "You must have SAS Enterprise Guide 4 or SAS Add-In for Microsoft Office 2.1 installed."
	Log "The project templates were not copied."
	WScript.Quit
End If

' Deploy the C# files
CSharpDir = GetVCDirectory
If CSharpDir <> "" Then
	Log "Copying C# templates to " & CSharpDir & "VC#Wizards\"
	FSO.CopyFolder WSH.CurrentDirectory & "\CSharpEG4AddInWiz", CSharpDir & "VC#Wizards\", True
	FSO.CopyFile WSH.CurrentDirectory & "\CSharpEG4AddIn.vsdir", CSharpDir & "CSharpProjects\", True
	FSO.CopyFile WSH.CurrentDirectory & "\CSharpEG4AddIn.vsz", CSharpDir & "CSharpProjects\", True
Else
	Log "C# templates were not copied"
End If

' Deploy the VB files
VBDir = GetVBDirectory
If VBDir <> "" Then
	Log "Copying VB.NET templates to " & VBDir & "VBWizards\"
	FSO.CopyFolder WSH.CurrentDirectory & "\VBEG4AddInWiz", VBDir & "VBWizards\", True
	FSO.CopyFile WSH.CurrentDirectory & "\VBEG4AddIn.vsdir", VBDir & "VBProjects\", True
	FSO.CopyFile WSH.CurrentDirectory & "\VBEG4Addin.vsz", VBDir & "VBProjects\", True
Else
	Log "VB.NET templates were not copied"
End If

' Look up the C# product directory
Function GetVCDirectory
	Dim strDir
	On Error Resume Next	
	strDir = WSH.RegRead("HKLM\SOFTWARE\Microsoft\VisualStudio\7.1\Setup\VC#\ProductDir")
	If Err.number = 0 Then
		Log "Found Visual Studio C# directories at " & strDir
	Else
		Log "Could not locate Visual Studio C# directories"
	End If

	GetVCDirectory = strDir
End Function

' Look up the VB.NET product directory
Function GetVBDirectory
	Dim strDir
	On Error Resume Next	
	strDir = WSH.RegRead("HKLM\SOFTWARE\Microsoft\VisualStudio\7.1\Setup\VB\ProductDir")
	If Err.number = 0 Then
		Log "Found Visual Studio VB.NET directories at " & strDir
	Else
		Log "Could not locate Visual Studio VB.NET directories"
	End If

	GetVBDirectory = strDir
End Function

' logging function
Sub Log(message)
	WScript.Echo(message)
End Sub

Function IsSASTasksInstalled
	Dim sharedFilesLoc
	On Error Resume Next
	sharedFilesLoc = WSH.RegRead("HKLM\SOFTWARE\SAS Institute Inc.\Common Data\Shared Files\")
	If FSO.FileExists(sharedFilesLoc & "\BIClientTasks\4\SAS.Shared.AddIns.dll") Then
		IsSASTasksInstalled = True
	Else
		IsSASTasksInstalled = False
	End If
	
	If Err.number <> 0 Then
		IsSASTasksInstalled = False	
	End If
End Function
